import { EventEmitter } from "events";
import { Candle } from "../types/types_ohlc";
import { FunctionRegistry } from "./feature_dsl_parser";
import { StrategySchema, StrategyTrade, StrategyReport } from "../types/types-strategy";
export declare class StrategyRunner extends EventEmitter {
    private readonly candles;
    private readonly strategy;
    private readonly function_registry;
    private readonly warmup_period;
    private readonly lookback_period;
    private start_time;
    private trades;
    private capital;
    private state;
    private candle_decisions;
    constructor(candles: Candle[], strategy: StrategySchema, function_registry: FunctionRegistry);
    /**
     * Validates the strategy configuration to ensure it meets minimum requirements
     * and has consistent settings.
     * @throws Error if the strategy configuration is invalid
     */
    private evaluateStrategy;
    run(): Promise<StrategyTrade[]>;
    private try_entry;
    private try_exit;
    get_report(): StrategyReport;
}
